ome-xml 5.2.3

Classes | Public Member Functions | Static Public Member Functions | Protected Member Functions | Private Member Functions | Private Attributes | List of all members
ome::xml::model::Channel Class Reference

Channel model object. More...

`#include <ome/xml/model/Channel.h>`

Inheritance diagram for ome::xml::model::Channel:
[legend]
Collaboration diagram for ome::xml::model::Channel:
[legend]

## Classes
class | Impl
| Private implementation details of Channel model object. More...

## Public Member Functions
| Channel ()
| Default constructor.
| Channel (const Channel &copy)
| Copy constructor. More...
virtual | ~Channel ()
| Destructor.
const std::string & | elementName () const
| Get the element name of this model object. More...
bool | validElementName (const std::string &name) const
| Check if a given element name is valid for processing by this model object. More...
virtual void | update (const common::xml::dom::Element &element, ome::xml::model::OMEModel &model)
| Update the object hierarchy recursively from an XML DOM tree. More...
bool | link (ome::compat::shared_ptr< Reference > &reference, ome::compat::shared_ptr< ome::xml::model::OMEModelObject > &object)
| Link a given OME model object to this model object. More...
ome::compat::shared_ptr< ome::xml::model::primitives::Quantity< ome::xml::model::enums::UnitsLength > > & | getPinholeSize ()
| Get the PinholeSize property. More...
const ome::compat::shared_ptr< ome::xml::model::primitives::Quantity< ome::xml::model::enums::UnitsLength > > & | getPinholeSize () const
| Get the PinholeSize property. More...
void | setPinholeSize (const ome::compat::shared_ptr< ome::xml::model::primitives::Quantity< ome::xml::model::enums::UnitsLength > > &pinholeSize)
| Set the PinholeSize property. More...
ome::compat::shared_ptr< std::string > | getName ()
| Get the Name property. More...
const ome::compat::shared_ptr< std::string > | getName () const
| Get the Name property. More...
void | setName (ome::compat::shared_ptr< std::string > &name)
| Set the Name property. More...
ome::compat::shared_ptr< ome::xml::model::enums::AcquisitionMode > | getAcquisitionMode ()
| Get the AcquisitionMode property. More...
const ome::compat::shared_ptr< ome::xml::model::enums::AcquisitionMode > | getAcquisitionMode () const
| Get the AcquisitionMode property. More...
void | setAcquisitionMode (ome::compat::shared_ptr< ome::xml::model::enums::AcquisitionMode > &acquisitionMode)
| Set the AcquisitionMode property. More...
ome::compat::shared_ptr< ome::xml::model::primitives::Color > | getColor ()
| Get the Color property. More...
const ome::compat::shared_ptr< ome::xml::model::primitives::Color > | getColor () const
| Get the Color property. More...
void | setColor (ome::compat::shared_ptr< ome::xml::model::primitives::Color > &color)
| Set the Color property. More...
ome::compat::shared_ptr< ome::xml::model::enums::ContrastMethod > | getContrastMethod ()
| Get the ContrastMethod property. More...
const ome::compat::shared_ptr< ome::xml::model::enums::ContrastMethod > | getContrastMethod () const
| Get the ContrastMethod property. More...
void | setContrastMethod (ome::compat::shared_ptr< ome::xml::model::enums::ContrastMethod > &contrastMethod)
| Set the ContrastMethod property. More...
ome::compat::shared_ptr< ome::xml::model::primitives::Quantity< ome::xml::model::enums::UnitsLength, ome::xml::model::primitives::PositiveFloat > > & | getExcitationWavelength ()
| Get the ExcitationWavelength property. More...
const ome::compat::shared_ptr< ome::xml::model::primitives::Quantity< ome::xml::model::enums::UnitsLength, ome::xml::model::primitives::PositiveFloat > > & | getExcitationWavelength () const
| Get the ExcitationWavelength property. More...
void | setExcitationWavelength (const ome::compat::shared_ptr< ome::xml::model::primitives::Quantity< ome::xml::model::enums::UnitsLength, ome::xml::model::primitives::PositiveFloat > > &excitationWavelength)
| Set the ExcitationWavelength property. More...
ome::compat::shared_ptr< ome::xml::model::enums::IlluminationType > | getIlluminationType ()
| Get the IlluminationType property. More...
const ome::compat::shared_ptr< ome::xml::model::enums::IlluminationType > | getIlluminationType () const
| Get the IlluminationType property. More...
void | setIlluminationType (ome::compat::shared_ptr< ome::xml::model::enums::IlluminationType > &illuminationType)
| Set the IlluminationType property. More...
ome::compat::shared_ptr< std::string > | getFluor ()
| Get the Fluor property. More...
const ome::compat::shared_ptr< std::string > | getFluor () const
| Get the Fluor property. More...
void | setFluor (ome::compat::shared_ptr< std::string > &fluor)
| Set the Fluor property. More...
ome::compat::shared_ptr< int32_t > | getPockelCellSetting ()
| Get the PockelCellSetting property. More...
const ome::compat::shared_ptr< int32_t > | getPockelCellSetting () const
| Get the PockelCellSetting property. More...
void | setPockelCellSetting (ome::compat::shared_ptr< int32_t > &pockelCellSetting)
| Set the PockelCellSetting property. More...
ome::compat::shared_ptr< double > | getNDFilter ()
| Get the NDFilter property. More...
const ome::compat::shared_ptr< double > | getNDFilter () const
| Get the NDFilter property. More...
void | setNDFilter (ome::compat::shared_ptr< double > &ndFilter)
| Set the NDFilter property. More...
ome::compat::shared_ptr< ome::xml::model::primitives::Quantity< ome::xml::model::enums::UnitsLength, ome::xml::model::primitives::PositiveFloat > > & | getEmissionWavelength ()
| Get the EmissionWavelength property. More...
const ome::compat::shared_ptr< ome::xml::model::primitives::Quantity< ome::xml::model::enums::UnitsLength, ome::xml::model::primitives::PositiveFloat > > & | getEmissionWavelength () const
| Get the EmissionWavelength property. More...
void | setEmissionWavelength (const ome::compat::shared_ptr< ome::xml::model::primitives::Quantity< ome::xml::model::enums::UnitsLength, ome::xml::model::primitives::PositiveFloat > > &emissionWavelength)
| Set the EmissionWavelength property. More...
const std::string & | getID () const
| Get the ID property. More...
void | setID (const std::string &id)
| Set the ID property. More...
ome::compat::shared_ptr< ome::xml::model::primitives::PositiveInteger > | getSamplesPerPixel ()
| Get the SamplesPerPixel property. More...
const ome::compat::shared_ptr< ome::xml::model::primitives::PositiveInteger > | getSamplesPerPixel () const
| Get the SamplesPerPixel property. More...
void | setSamplesPerPixel (ome::compat::shared_ptr< ome::xml::model::primitives::PositiveInteger > &samplesPerPixel)
| Set the SamplesPerPixel property. More...
ome::compat::shared_ptr< ome::xml::model::LightSourceSettings > | getLightSourceSettings ()
| Get the LightSourceSettings property. More...
const ome::compat::shared_ptr< ome::xml::model::LightSourceSettings > | getLightSourceSettings () const
| Get the LightSourceSettings property. More...
void | setLightSourceSettings (ome::compat::shared_ptr< ome::xml::model::LightSourceSettings > &lightSourceSettings)
| Set the LightSourceSettings property. More...
ome::compat::shared_ptr< ome::xml::model::DetectorSettings > | getDetectorSettings ()
| Get the DetectorSettings property. More...
const ome::compat::shared_ptr< ome::xml::model::DetectorSettings > | getDetectorSettings () const
| Get the DetectorSettings property. More...
void | setDetectorSettings (ome::compat::shared_ptr< ome::xml::model::DetectorSettings > &detectorSettings)
| Set the DetectorSettings property. More...
ome::compat::weak_ptr< ome::xml::model::FilterSet > | getLinkedFilterSet ()
| Get linked FilterSet. More...
const ome::compat::weak_ptr< ome::xml::model::FilterSet > | getLinkedFilterSet () const
| Get linked FilterSet. More...
void | linkFilterSet (ome::compat::shared_ptr< ome::xml::model::FilterSet > &filterSet)
| Link FilterSet. More...
void | unlinkFilterSet (ome::compat::shared_ptr< ome::xml::model::FilterSet > &filterSet)
| Unlink FilterSet. More...
OMEModelObject::indexed_container< ome::xml::model::Annotation, ome::compat::weak_ptr >::type::size_type | sizeOfLinkedAnnotationList () const
| Get size of linked Annotation list. More...
OMEModelObject::indexed_container< ome::xml::model::Annotation, ome::compat::weak_ptr >::type | getLinkedAnnotationList () const
| Get the linked Annotation list. More...
const ome::compat::weak_ptr< ome::xml::model::Annotation > & | getLinkedAnnotation (OMEModelObject::indexed_container< ome::xml::model::Annotation, ome::compat::weak_ptr >::type::size_type index) const
| Get linked Annotation. More...
const ome::compat::weak_ptr< ome::xml::model::Annotation > & | setLinkedAnnotation (OMEModelObject::indexed_container< ome::xml::model::Annotation, ome::compat::weak_ptr >::type::size_type index, const ome::compat::shared_ptr< ome::xml::model::Annotation > &annotation)
| Set linked Annotation. More...
bool | linkAnnotation (const ome::compat::shared_ptr< ome::xml::model::Annotation > &annotation)
| Link Annotation. More...
bool | unlinkAnnotation (const ome::compat::shared_ptr< ome::xml::model::Annotation > &annotation)
| Unlink Annotation. More...
ome::compat::shared_ptr< ome::xml::model::LightPath > | getLightPath ()
| Get the LightPath property. More...
const ome::compat::shared_ptr< ome::xml::model::LightPath > | getLightPath () const
| Get the LightPath property. More...
void | setLightPath (ome::compat::shared_ptr< ome::xml::model::LightPath > &lightPath)
| Set the LightPath property. More...
ome::compat::weak_ptr< ome::xml::model::Pixels > | getPixels ()
| Get the Pixels property. More...
const ome::compat::weak_ptr< ome::xml::model::Pixels > | getPixels () const
| Get the Pixels property. More...
void | setPixels (ome::compat::weak_ptr< ome::xml::model::Pixels > &pixels_BackReference)
| Set the Pixels property. More...
virtual common::xml::dom::Element | asXMLElement (common::xml::dom::Document &document) const
| Transform the object hierarchy rooted at this element to XML. More...
const std::string & | getXMLNamespace () const
| Get the XML namespace for this model object. More...
Public Member Functions inherited from ome::xml::model::detail::OMEModelObject
virtual | ~OMEModelObject ()
| Destructor.
virtual void | update (const common::xml::dom::Element &element, ::ome::xml::model::OMEModel &model)
| Update the object hierarchy recursively from an XML DOM tree. More...
virtual bool | link (ome::compat::shared_ptr< Reference > &reference, ome::compat::shared_ptr< ::ome::xml::model::OMEModelObject > &object)
| Link a given OME model object to this model object. More...
Public Member Functions inherited from ome::xml::model::OMEModelObject
virtual bool | link (ome::compat::shared_ptr< Reference > &reference, ome::compat::shared_ptr< OMEModelObject > &object)=0
| Link a given OME model object to this model object. More...

## Static Public Member Functions
static ome::compat::shared_ptr< Channel > | create (const common::xml::dom::Element &element, ome::xml::model::OMEModel &model)
| Create a Channel model object from DOM element. More...
Static Public Member Functions inherited from ome::xml::model::detail::OMEModelObject
static std::vector< common::xml::dom::Element > | getChildrenByTagName (const common::xml::dom::Element &parent, const std::string &name)
| Retrieve all the children of an element that have a given tag name. More...
static std::string | stripNamespacePrefix (const std::string &value)
| Strip the namespace prefix from a tag name. More...

## Protected Member Functions
virtual common::xml::dom::Element | asXMLElementInternal (common::xml::dom::Document &document, common::xml::dom::Element &element) const
| Transform the object hierarchy rooted at this element to XML. More...
Protected Member Functions inherited from ome::xml::model::detail::OMEModelObject
| OMEModelObject (const std::string &objectType="OMEModelObject")
| Constructor.
| OMEModelObject (const OMEModelObject &copy)
| Copy constructor. More...
template<class C , typename T >
bool | contains (const C &container, const ome::compat::shared_ptr< T > &element)
| Check if a container contains a particular element. More...
Protected Member Functions inherited from ome::xml::model::OMEModelObject
| OMEModelObject ()
| Constructor.

## Private Member Functions
Channel & | operator= (const Channel &)
| Assignment operator (deleted).

## Private Attributes
ome::compat::shared_ptr< Impl > | impl
| Private implementation details.

## Additional Inherited Members
Protected Attributes inherited from ome::xml::model::detail::OMEModelObject
ome::common::Logger | logger
| Message logger.

## Detailed Description

Channel model object.

## Constructor & Destructor Documentation

## § Channel()

ome::xml::model::Channel::Channel | ( | const Channel & | copy | ) |

Copy constructor.

Parameters

  copy | the Channel to copy.

## Member Function Documentation

## § asXMLElement()

common::xml::dom::Element ome::xml::model::Channel::asXMLElement | ( | common::xml::dom::Document & | document | ) | const
| virtual

Transform the object hierarchy rooted at this element to XML.

Parameters

  document | document for element creation

Returns
  an XML DOM tree root element for this model object.

Implements ome::xml::model::OMEModelObject.

References asXMLElementInternal(), ome::common::xml::dom::Document::createElementNS(), and getXMLNamespace().

## § asXMLElementInternal()

common::xml::dom::Element ome::xml::model::Channel::asXMLElementInternal | ( | common::xml::dom::Document & | document,
|  | common::xml::dom::Element & | element
| ) |  | const
| protectedvirtual

Transform the object hierarchy rooted at this element to XML.

This internal implementation of asXMLelement also requires an XML element, which must not be null, or may be instantiated and passed from superclasses.

Parameters

  document | XML document for element creation.
  element | XML element for setting model data.

Returns
  an XML DOM tree root element for this model object.

Implements ome::xml::model::detail::OMEModelObject.

References ome::common::xml::dom::Node::appendChild(), ome::xml::model::detail::OMEModelObject::asXMLElementInternal(), ome::common::xml::dom::Document::createElementNS(), getXMLNamespace(), impl, and ome::common::xml::dom::Element::setAttribute().

Referenced by asXMLElement().

Here is the caller graph for this function:

## § create()

ome::compat::shared_ptr< Channel > ome::xml::model::Channel::create | ( | const common::xml::dom::Element & | element,
|  | ome::xml::model::OMEModel & | model
| ) |  |
| static

Create a Channel model object from DOM element.

Parameters

  element | root of the XML DOM tree to from which to construct the model object graph.
  model | handler for the OME model used to track instances and references seen during the update.

Exceptions

  EnumerationException | if there is an error instantiating an enumeration during model object creation, or ModelException if there are any consistency or validity errors found during processing.

Returns
  a new model object.

Referenced by ome::xml::model::Pixels::update().

Here is the caller graph for this function:

## § elementName()

const std::string & ome::xml::model::Channel::elementName | ( |  | ) | const
| virtual

Get the element name of this model object.

This will be the most-derived class name.

Returns
  the element type.

Implements ome::xml::model::OMEModelObject.

## § getAcquisitionMode() [1/2]

ome::compat::shared_ptr< ome::xml::model::enums::AcquisitionMode > ome::xml::model::Channel::getAcquisitionMode | ( |  | ) |

Get the AcquisitionMode property.

Returns
  the AcquisitionMode property.

References impl.

## § getAcquisitionMode() [2/2]

const ome::compat::shared_ptr< ome::xml::model::enums::AcquisitionMode > ome::xml::model::Channel::getAcquisitionMode | ( |  | ) | const

Get the AcquisitionMode property.

Returns
  the AcquisitionMode property.

References impl.

## § getColor() [1/2]

ome::compat::shared_ptr< ome::xml::model::primitives::Color > ome::xml::model::Channel::getColor | ( |  | ) |

Get the Color property.

Returns
  the Color property.

References impl.

## § getColor() [2/2]

const ome::compat::shared_ptr< ome::xml::model::primitives::Color > ome::xml::model::Channel::getColor | ( |  | ) | const

Get the Color property.

Returns
  the Color property.

References impl.

## § getContrastMethod() [1/2]

ome::compat::shared_ptr< ome::xml::model::enums::ContrastMethod > ome::xml::model::Channel::getContrastMethod | ( |  | ) |

Get the ContrastMethod property.

Returns
  the ContrastMethod property.

References impl.

## § getContrastMethod() [2/2]

const ome::compat::shared_ptr< ome::xml::model::enums::ContrastMethod > ome::xml::model::Channel::getContrastMethod | ( |  | ) | const

Get the ContrastMethod property.

Returns
  the ContrastMethod property.

References impl.

## § getDetectorSettings() [1/2]

ome::compat::shared_ptr< ome::xml::model::DetectorSettings > ome::xml::model::Channel::getDetectorSettings | ( |  | ) |

Get the DetectorSettings property.

Returns
  the DetectorSettings property.

References impl.

## § getDetectorSettings() [2/2]

const ome::compat::shared_ptr< ome::xml::model::DetectorSettings > ome::xml::model::Channel::getDetectorSettings | ( |  | ) | const

Get the DetectorSettings property.

Returns
  the DetectorSettings property.

References impl.

## § getEmissionWavelength() [1/2]

ome::compat::shared_ptr< ome::xml::model::primitives::Quantity< ome::xml::model::enums::UnitsLength, ome::xml::model::primitives::PositiveFloat > > & ome::xml::model::Channel::getEmissionWavelength | ( |  | ) |

Get the EmissionWavelength property.

Returns
  the EmissionWavelength property.

References impl.

## § getEmissionWavelength() [2/2]

const ome::compat::shared_ptr< ome::xml::model::primitives::Quantity< ome::xml::model::enums::UnitsLength, ome::xml::model::primitives::PositiveFloat > > & ome::xml::model::Channel::getEmissionWavelength | ( |  | ) | const

Get the EmissionWavelength property.

Returns
  the EmissionWavelength property.

References impl.

## § getExcitationWavelength() [1/2]

ome::compat::shared_ptr< ome::xml::model::primitives::Quantity< ome::xml::model::enums::UnitsLength, ome::xml::model::primitives::PositiveFloat > > & ome::xml::model::Channel::getExcitationWavelength | ( |  | ) |

Get the ExcitationWavelength property.

Returns
  the ExcitationWavelength property.

References impl.

## § getExcitationWavelength() [2/2]

const ome::compat::shared_ptr< ome::xml::model::primitives::Quantity< ome::xml::model::enums::UnitsLength, ome::xml::model::primitives::PositiveFloat > > & ome::xml::model::Channel::getExcitationWavelength | ( |  | ) | const

Get the ExcitationWavelength property.

Returns
  the ExcitationWavelength property.

References impl.

## § getFluor() [1/2]

ome::compat::shared_ptr< std::string > ome::xml::model::Channel::getFluor | ( |  | ) |

Get the Fluor property.

Returns
  the Fluor property.

References impl.

## § getFluor() [2/2]

const ome::compat::shared_ptr< std::string > ome::xml::model::Channel::getFluor | ( |  | ) | const

Get the Fluor property.

Returns
  the Fluor property.

References impl.

## § getID()

const std::string & ome::xml::model::Channel::getID | ( |  | ) | const

Get the ID property.

Returns
  the ID property.

References impl.

Referenced by update().

Here is the caller graph for this function:

## § getIlluminationType() [1/2]

ome::compat::shared_ptr< ome::xml::model::enums::IlluminationType > ome::xml::model::Channel::getIlluminationType | ( |  | ) |

Get the IlluminationType property.

Returns
  the IlluminationType property.

References impl.

## § getIlluminationType() [2/2]

const ome::compat::shared_ptr< ome::xml::model::enums::IlluminationType > ome::xml::model::Channel::getIlluminationType | ( |  | ) | const

Get the IlluminationType property.

Returns
  the IlluminationType property.

References impl.

## § getLightPath() [1/2]

ome::compat::shared_ptr< ome::xml::model::LightPath > ome::xml::model::Channel::getLightPath | ( |  | ) |

Get the LightPath property.

Returns
  the LightPath property.

References impl.

## § getLightPath() [2/2]

const ome::compat::shared_ptr< ome::xml::model::LightPath > ome::xml::model::Channel::getLightPath | ( |  | ) | const

Get the LightPath property.

Returns
  the LightPath property.

References impl.

## § getLightSourceSettings() [1/2]

ome::compat::shared_ptr< ome::xml::model::LightSourceSettings > ome::xml::model::Channel::getLightSourceSettings | ( |  | ) |

Get the LightSourceSettings property.

Returns
  the LightSourceSettings property.

References impl.

## § getLightSourceSettings() [2/2]

const ome::compat::shared_ptr< ome::xml::model::LightSourceSettings > ome::xml::model::Channel::getLightSourceSettings | ( |  | ) | const

Get the LightSourceSettings property.

Returns
  the LightSourceSettings property.

References impl.

## § getLinkedAnnotation()

const ome::compat::weak_ptr< ome::xml::model::Annotation > & ome::xml::model::Channel::getLinkedAnnotation | ( | OMEModelObject::indexed_container< ome::xml::model::Annotation, ome::compat::weak_ptr >::type::size_type | index | ) | const

Get linked Annotation.

Parameters

  index | the index number of the Annotation.

Returns
  a weak pointer to the Annotation.

Exceptions

  std::out_of_range | if the index is invalid.

References impl.

## § getLinkedAnnotationList()

OMEModelObject::indexed_container< ome::xml::model::Annotation, ome::compat::weak_ptr >::type ome::xml::model::Channel::getLinkedAnnotationList | ( |  | ) | const

Get the linked Annotation list.

Returns
  a reference to the list.

References impl.

## § getLinkedFilterSet() [1/2]

ome::compat::weak_ptr< ome::xml::model::FilterSet > ome::xml::model::Channel::getLinkedFilterSet | ( |  | ) |

Get linked FilterSet.

Returns
  the linked FilterSet. The pointer may be null.

References impl.

## § getLinkedFilterSet() [2/2]

const ome::compat::weak_ptr< ome::xml::model::FilterSet > ome::xml::model::Channel::getLinkedFilterSet | ( |  | ) | const

Get linked FilterSet.

Returns
  the linked FilterSet. The pointer may be null.

References impl.

## § getName() [1/2]

ome::compat::shared_ptr< std::string > ome::xml::model::Channel::getName | ( |  | ) |

Get the Name property.

Returns
  the Name property.

References impl.

## § getName() [2/2]

const ome::compat::shared_ptr< std::string > ome::xml::model::Channel::getName | ( |  | ) | const

Get the Name property.

Returns
  the Name property.

References impl.

## § getNDFilter() [1/2]

ome::compat::shared_ptr< double > ome::xml::model::Channel::getNDFilter | ( |  | ) |

Get the NDFilter property.

Returns
  the NDFilter property.

References impl.

## § getNDFilter() [2/2]

const ome::compat::shared_ptr< double > ome::xml::model::Channel::getNDFilter | ( |  | ) | const

Get the NDFilter property.

Returns
  the NDFilter property.

References impl.

## § getPinholeSize() [1/2]

ome::compat::shared_ptr< ome::xml::model::primitives::Quantity< ome::xml::model::enums::UnitsLength > > & ome::xml::model::Channel::getPinholeSize | ( |  | ) |

Get the PinholeSize property.

Returns
  the PinholeSize property.

References impl.

## § getPinholeSize() [2/2]

const ome::compat::shared_ptr< ome::xml::model::primitives::Quantity< ome::xml::model::enums::UnitsLength > > & ome::xml::model::Channel::getPinholeSize | ( |  | ) | const

Get the PinholeSize property.

Returns
  the PinholeSize property.

References impl.

## § getPixels() [1/2]

ome::compat::weak_ptr< ome::xml::model::Pixels > ome::xml::model::Channel::getPixels | ( |  | ) |

Get the Pixels property.

Returns
  the Pixels property.

References impl.

## § getPixels() [2/2]

const ome::compat::weak_ptr< ome::xml::model::Pixels > ome::xml::model::Channel::getPixels | ( |  | ) | const

Get the Pixels property.

Returns
  the Pixels property.

References impl.

## § getPockelCellSetting() [1/2]

ome::compat::shared_ptr< int32_t > ome::xml::model::Channel::getPockelCellSetting | ( |  | ) |

Get the PockelCellSetting property.

Returns
  the PockelCellSetting property.

References impl.

## § getPockelCellSetting() [2/2]

const ome::compat::shared_ptr< int32_t > ome::xml::model::Channel::getPockelCellSetting | ( |  | ) | const

Get the PockelCellSetting property.

Returns
  the PockelCellSetting property.

References impl.

## § getSamplesPerPixel() [1/2]

ome::compat::shared_ptr< ome::xml::model::primitives::PositiveInteger > ome::xml::model::Channel::getSamplesPerPixel | ( |  | ) |

Get the SamplesPerPixel property.

Returns
  the SamplesPerPixel property.

References impl.

## § getSamplesPerPixel() [2/2]

const ome::compat::shared_ptr< ome::xml::model::primitives::PositiveInteger > ome::xml::model::Channel::getSamplesPerPixel | ( |  | ) | const

Get the SamplesPerPixel property.

Returns
  the SamplesPerPixel property.

References impl.

## § getXMLNamespace()

const std::string & ome::xml::model::Channel::getXMLNamespace | ( |  | ) | const
| virtual

Get the XML namespace for this model object.

Returns
  the XML namespace.

Implements ome::xml::model::OMEModelObject.

Referenced by asXMLElement(), and asXMLElementInternal().

Here is the caller graph for this function:

## § link()

bool ome::xml::model::Channel::link | ( | ome::compat::shared_ptr< Reference > & | reference,
|  | ome::compat::shared_ptr< ome::xml::model::OMEModelObject > & | object
| ) |  |

Link a given OME model object to this model object.

Parameters

  reference | type qualifier for the reference. This should be the corresponding reference type for object. If, for example, object is of type Image, reference must be of type ImageRef.
  object | Model object to link to.

Returns
  `true` if this model object was able to handle the reference, otherwise `false`.

Todo:
  the use of reference to provide type information for the type of object is unconventional and quite possibly unnecessary–a simple string or type_info would suffice for what it's being used for, if it's needed at all. Is this true for all cases? The implementation also needs to do strict checking of the object type; it's not currently failing if it's of the wrong type. This applies to all generated model objects implementing this interface.

Todo:
  This bit is silly; why do we have two dynamic_casts here.

Todo:
  This bit is silly; why do we have two dynamic_casts here.

References impl, ome::xml::model::detail::OMEModelObject::link(), ome::xml::model::FilterSet::linkChannel(), ome::xml::model::Annotation::linkChannel(), and ome::xml::model::detail::OMEModelObject::logger.

## § linkAnnotation()

bool ome::xml::model::Channel::linkAnnotation | ( | const ome::compat::shared_ptr< ome::xml::model::Annotation > & | annotation | ) |

Link Annotation.

Parameters

  annotation | the Annotation to link.

Returns
  `true` if the object was added to the internal annotationLinks list, otherwise `false`.

Todo:
  Why have a return value here; what is it used for? Is this an artifact of the Java API?

References impl.

## § linkFilterSet()

void ome::xml::model::Channel::linkFilterSet | ( | ome::compat::shared_ptr< ome::xml::model::FilterSet > & | filterSet | ) |

Link FilterSet.

Parameters

  filterSet | the FilterSet to link.

References impl.

## § setAcquisitionMode()

void ome::xml::model::Channel::setAcquisitionMode | ( | ome::compat::shared_ptr< ome::xml::model::enums::AcquisitionMode > & | acquisitionMode | ) |

Set the AcquisitionMode property.

Parameters

  acquisitionMode | the value to set.

References impl.

Referenced by update().

Here is the caller graph for this function:

## § setColor()

void ome::xml::model::Channel::setColor | ( | ome::compat::shared_ptr< ome::xml::model::primitives::Color > & | color | ) |

Set the Color property.

Parameters

  color | the value to set.

References impl.

Referenced by update().

Here is the caller graph for this function:

## § setContrastMethod()

void ome::xml::model::Channel::setContrastMethod | ( | ome::compat::shared_ptr< ome::xml::model::enums::ContrastMethod > & | contrastMethod | ) |

Set the ContrastMethod property.

Parameters

  contrastMethod | the value to set.

References impl.

Referenced by update().

Here is the caller graph for this function:

## § setDetectorSettings()

void ome::xml::model::Channel::setDetectorSettings | ( | ome::compat::shared_ptr< ome::xml::model::DetectorSettings > & | detectorSettings | ) |

Set the DetectorSettings property.

Parameters

  detectorSettings | the value to set.

References impl.

Referenced by update().

Here is the caller graph for this function:

## § setEmissionWavelength()

void ome::xml::model::Channel::setEmissionWavelength | ( | const ome::compat::shared_ptr< ome::xml::model::primitives::Quantity< ome::xml::model::enums::UnitsLength, ome::xml::model::primitives::PositiveFloat > > & | emissionWavelength | ) |

Set the EmissionWavelength property.

Parameters

  emissionWavelength | the value to set.

References impl.

Referenced by update().

Here is the caller graph for this function:

## § setExcitationWavelength()

void ome::xml::model::Channel::setExcitationWavelength | ( | const ome::compat::shared_ptr< ome::xml::model::primitives::Quantity< ome::xml::model::enums::UnitsLength, ome::xml::model::primitives::PositiveFloat > > & | excitationWavelength | ) |

Set the ExcitationWavelength property.

Parameters

  excitationWavelength | the value to set.

References impl.

Referenced by update().

Here is the caller graph for this function:

## § setFluor()

void ome::xml::model::Channel::setFluor | ( | ome::compat::shared_ptr< std::string > & | fluor | ) |

Set the Fluor property.

Parameters

  fluor | the value to set.

References impl.

Referenced by update().

Here is the caller graph for this function:

## § setID()

void ome::xml::model::Channel::setID | ( | const std::string & | id | ) |

Set the ID property.

Parameters

  id | the value to set.

References impl.

Referenced by update().

Here is the caller graph for this function:

## § setIlluminationType()

void ome::xml::model::Channel::setIlluminationType | ( | ome::compat::shared_ptr< ome::xml::model::enums::IlluminationType > & | illuminationType | ) |

Set the IlluminationType property.

Parameters

  illuminationType | the value to set.

References impl.

Referenced by update().

Here is the caller graph for this function:

## § setLightPath()

void ome::xml::model::Channel::setLightPath | ( | ome::compat::shared_ptr< ome::xml::model::LightPath > & | lightPath | ) |

Set the LightPath property.

Parameters

  lightPath | the value to set.

References impl.

Referenced by update().

Here is the caller graph for this function:

## § setLightSourceSettings()

void ome::xml::model::Channel::setLightSourceSettings | ( | ome::compat::shared_ptr< ome::xml::model::LightSourceSettings > & | lightSourceSettings | ) |

Set the LightSourceSettings property.

Parameters

  lightSourceSettings | the value to set.

References impl.

Referenced by update().

Here is the caller graph for this function:

## § setLinkedAnnotation()

const ome::compat::weak_ptr< ome::xml::model::Annotation > & ome::xml::model::Channel::setLinkedAnnotation | ( | OMEModelObject::indexed_container< ome::xml::model::Annotation, ome::compat::weak_ptr >::type::size_type | index,
|  | const ome::compat::shared_ptr< ome::xml::model::Annotation > & | annotation
| ) |  |

Set linked Annotation.

Note
  The index must be valid.

Parameters

  index | the index number of the Annotation.
  annotation | the Annotation to set.

Returns
  a weak pointer to the Annotation.

Exceptions

  std::out_of_range | if the index is invalid.

References impl.

## § setName()

void ome::xml::model::Channel::setName | ( | ome::compat::shared_ptr< std::string > & | name | ) |

Set the Name property.

Parameters

  name | the value to set.

References impl.

Referenced by update().

Here is the caller graph for this function:

## § setNDFilter()

void ome::xml::model::Channel::setNDFilter | ( | ome::compat::shared_ptr< double > & | ndFilter | ) |

Set the NDFilter property.

Parameters

  ndFilter | the value to set.

References impl.

Referenced by update().

Here is the caller graph for this function:

## § setPinholeSize()

void ome::xml::model::Channel::setPinholeSize | ( | const ome::compat::shared_ptr< ome::xml::model::primitives::Quantity< ome::xml::model::enums::UnitsLength > > & | pinholeSize | ) |

Set the PinholeSize property.

Parameters

  pinholeSize | the value to set.

References impl.

Referenced by update().

Here is the caller graph for this function:

## § setPixels()

void ome::xml::model::Channel::setPixels | ( | ome::compat::weak_ptr< ome::xml::model::Pixels > & | pixels_BackReference | ) |

Set the Pixels property.

Parameters

  pixels_BackReference | the value to set.

References impl.

## § setPockelCellSetting()

void ome::xml::model::Channel::setPockelCellSetting | ( | ome::compat::shared_ptr< int32_t > & | pockelCellSetting | ) |

Set the PockelCellSetting property.

Parameters

  pockelCellSetting | the value to set.

References impl.

Referenced by update().

Here is the caller graph for this function:

## § setSamplesPerPixel()

void ome::xml::model::Channel::setSamplesPerPixel | ( | ome::compat::shared_ptr< ome::xml::model::primitives::PositiveInteger > & | samplesPerPixel | ) |

Set the SamplesPerPixel property.

Parameters

  samplesPerPixel | the value to set.

References impl.

Referenced by update().

Here is the caller graph for this function:

## § sizeOfLinkedAnnotationList()

OMEModelObject::indexed_container< ome::xml::model::Annotation, ome::compat::weak_ptr >::type::size_type ome::xml::model::Channel::sizeOfLinkedAnnotationList | ( |  | ) | const

Get size of linked Annotation list.

Returns
  the size of the list.

References impl.

## § unlinkAnnotation()

bool ome::xml::model::Channel::unlinkAnnotation | ( | const ome::compat::shared_ptr< ome::xml::model::Annotation > & | annotation | ) |

Unlink Annotation.

Parameters

  annotation | the Annotation to unlink.

Returns
  `true` if the Annotation was unlinked, otherwise `false` if the Annotation was not linked and could hence not be unlinked.

Todo:

  Does the return value serve any useful purpose? Is this also inherited Java API?

  Doesn't the removal break the indexing?

  Does the removal deal with multiple instances; we aren't preventing duplicates on insertion.

References impl.

## § unlinkFilterSet()

void ome::xml::model::Channel::unlinkFilterSet | ( | ome::compat::shared_ptr< ome::xml::model::FilterSet > & | filterSet | ) |

Unlink FilterSet.

Parameters

  filterSet | the FilterSet to unlink.

Todo:
  This method is fairly pointless since it's equivalent to linking a null pointer. It could call `link(0)` internally.

References impl.

## § update()

void ome::xml::model::Channel::update | ( | const common::xml::dom::Element & | element,
|  | ome::xml::model::OMEModel & | model
| ) |  |
| virtual

Update the object hierarchy recursively from an XML DOM tree.

Note
  No properties are removed, only added or updated.

Parameters

  element | root of the XML DOM tree to from which to construct the model object graph.
  model | handler for the OME model used to track instances and references seen during the update.

Exceptions

  EnumerationException | if there is an error instantiating an enumeration during model object creation, or ModelException if there are any consistency or validity errors found during processing.

Implements ome::xml::model::OMEModelObject.

References ome::xml::model::OMEModel::addModelObject(), ome::xml::model::OMEModel::addReference(), ome::xml::model::LightPath::create(), ome::xml::model::DetectorSettings::create(), ome::xml::model::LightSourceSettings::create(), ome::common::xml::dom::Element::getAttribute(), ome::xml::model::detail::OMEModelObject::getChildrenByTagName(), getID(), ome::common::xml::dom::Element::getTagName(), ome::common::xml::dom::Element::hasAttribute(), ome::xml::model::detail::OMEModelObject::logger, setAcquisitionMode(), setColor(), setContrastMethod(), setDetectorSettings(), setEmissionWavelength(), setExcitationWavelength(), setFluor(), setID(), setIlluminationType(), setLightPath(), setLightSourceSettings(), setName(), setNDFilter(), setPinholeSize(), setPockelCellSetting(), setSamplesPerPixel(), ome::xml::model::detail::OMEModelObject::stripNamespacePrefix(), ome::xml::model::detail::OMEModelObject::update(), and validElementName().

## § validElementName()

bool ome::xml::model::Channel::validElementName | ( | const std::string & | name | ) | const
| virtual

Check if a given element name is valid for processing by this model object.

Used for processing nodes when interitance is involved.

Parameters

  name | the element name to check.

Returns
  `true` if valid, `false` if invalid.

Implements ome::xml::model::detail::OMEModelObject.

References ome::xml::model::detail::OMEModelObject::validElementName().

Referenced by update().

Here is the caller graph for this function:

The documentation for this class was generated from the following files:

- ome/xml/model/Channel.h
- ome/xml/model/Channel.cpp